% --------------------------------------------------------------
% N Queens Problem
% Viktor Engelmann
% www.AlgorithMan.de
% --------------------------------------------------------------
% this code is provided under the terms of the GNU General
% Public License v3. See gpl3.txt for details
% --------------------------------------------------------------


generiere_liste(0,[]):-!.
generiere_liste(T,[T|L]):-
   T1 is T - 1,
   generiere_liste(T1,L).

   
einfuegen(L,X,[X|L]).
einfuegen([X|R],Y,[X|L]):-
   einfuegen(R,Y,L).
   
   
permutiere([],[]).
permutiere([X|R],L):-
   permutiere(R,L2),
   einfuegen(L2,X,L).

   
damen(X,P):-
   generiere_liste(X,L),
   permutiere(L,P),
   sicher(P).
   
   
sicher([]).
sicher([X|R]):-
   sicher(R),
   bedroht_nicht(X,R,1).
   
   
bedroht_nicht(_,[],_).
bedroht_nicht(Dame,[Weitere|Rest],Abstand):-
   Dame + Abstand =\= Weitere,
   Dame - Abstand =\= Weitere,
   Abstand1 is Abstand + 1,
   bedroht_nicht(Dame,Rest,Abstand1).
